BEGIN;

SET SCHEMA ; -- PUT YOUR SCHEMA NAME HERE!

--
-- Data volume optimizations
--
DELETE FROM matchstates WHERE playmode != 'play_on'; -- This may take ~10h
DELETE FROM playercommands WHERE teamname_fk != 'HELIOS2019'; -- This may take extra ~1h
DELETE FROM playercommands WHERE unum_fk = 1; -- May take extra ~10min

--
-- Indexes
--
--  This one is useful when fetching (randomly or not) command batches of a specific type
--  This should not help much if the type is dash or tuen, but greatly speed if the type is kick or tackle
--      because those are very scarse in the table
--  Having the playerstate_id_fk and matchstate_id_fk slows a bit the search but having it in the index table speeds up looking up
--       the related matchstate or playerstate, which is what one usually wants in sequence.
CREATE INDEX playercommands_playercommand_type_matchstate_playerstate ON playercommands USING btree(playercommand_type, matchstate_id_fk, playerstate_id_fk);

--
-- Materialized view
--
--  This materialized view is used so we can quickly get a batch of random rows.
--  For this, we JOIN the materialized with a randomly shuffled series.
--  NOTE: This is not very performatic by itself for our purpose and must be indexed too.
--
CREATE MATERIALIZED VIEW shuffled_condensed_matchstates AS
	select row_number() over () as random_id, condensed.*
	from (
		select * from get_batchof_condensed_matchstates(
            (select count(*) from matchstates)::int
        )
		order by random()
	) as condensed
WITH DATA;
CREATE INDEX mview_shuffled_condensed_matchstates_random_id ON shuffled_condensed_matchstates USING btree(random_id);
--
--  Getters for random rows of the shuffled_condensed_matchstates
--
--      Gets batch of random condensed matchstates
CREATE OR REPLACE FUNCTION get_random_condensed_matchstates (batch_size int)
RETURNS TABLE(
	random_id int,
	matchstate_id int,
	left_teamname varchar(32),
    right_teamname varchar(32),
    cycle int,
    ball_x numeric,
    ball_y numeric,
    ball_vx numeric,
    ball_vy numeric,
 	l1_x numeric,
 	l1_y numeric,
 	l1_body numeric,
 	l1_vx numeric,
 	l1_vy numeric,
 	l1_dash_power_rate numeric,
	l1_effort_min numeric,
 	l1_effort_max numeric,
 	l1_extra_stamina numeric,
 	l1_inertia_moment numeric,
 	l1_kick_rand numeric,
 	l1_kickable_margin numeric,
 	l1_player_decay numeric,
 	l2_x numeric,
 	l2_y numeric,
 	l2_body numeric,
 	l2_vx numeric,
 	l2_vy numeric,
 	l2_dash_power_rate numeric,
	l2_effort_min numeric,
 	l2_effort_max numeric,
 	l2_extra_stamina numeric,
 	l2_inertia_moment numeric,
 	l2_kick_rand numeric,
 	l2_kickable_margin numeric,
 	l2_player_decay numeric,
 	l3_x numeric,
 	l3_y numeric,
 	l3_body numeric,
 	l3_vx numeric,
 	l3_vy numeric,
 	l3_dash_power_rate numeric,
	l3_effort_min numeric,
 	l3_effort_max numeric,
 	l3_extra_stamina numeric,
 	l3_inertia_moment numeric,
 	l3_kick_rand numeric,
 	l3_kickable_margin numeric,
 	l3_player_decay numeric,
 	l4_x numeric,
 	l4_y numeric,
 	l4_body numeric,
 	l4_vx numeric,
 	l4_vy numeric,
 	l4_dash_power_rate numeric,
	l4_effort_min numeric,
 	l4_effort_max numeric,
 	l4_extra_stamina numeric,
 	l4_inertia_moment numeric,
 	l4_kick_rand numeric,
 	l4_kickable_margin numeric,
 	l4_player_decay numeric,
 	l5_x numeric,
 	l5_y numeric,
 	l5_body numeric,
 	l5_vx numeric,
 	l5_vy numeric,
 	l5_dash_power_rate numeric,
	l5_effort_min numeric,
 	l5_effort_max numeric,
 	l5_extra_stamina numeric,
 	l5_inertia_moment numeric,
 	l5_kick_rand numeric,
 	l5_kickable_margin numeric,
 	l5_player_decay numeric,
 	l6_x numeric,
 	l6_y numeric,
 	l6_body numeric,
 	l6_vx numeric,
 	l6_vy numeric,
 	l6_dash_power_rate numeric,
	l6_effort_min numeric,
 	l6_effort_max numeric,
 	l6_extra_stamina numeric,
 	l6_inertia_moment numeric,
 	l6_kick_rand numeric,
 	l6_kickable_margin numeric,
 	l6_player_decay numeric,
 	l7_x numeric,
 	l7_y numeric,
 	l7_body numeric,
 	l7_vx numeric,
 	l7_vy numeric,
 	l7_dash_power_rate numeric,
	l7_effort_min numeric,
 	l7_effort_max numeric,
 	l7_extra_stamina numeric,
 	l7_inertia_moment numeric,
 	l7_kick_rand numeric,
 	l7_kickable_margin numeric,
 	l7_player_decay numeric,
 	l8_x numeric,
 	l8_y numeric,
 	l8_body numeric,
 	l8_vx numeric,
 	l8_vy numeric,
 	l8_dash_power_rate numeric,
	l8_effort_min numeric,
 	l8_effort_max numeric,
 	l8_extra_stamina numeric,
 	l8_inertia_moment numeric,
 	l8_kick_rand numeric,
 	l8_kickable_margin numeric,
 	l8_player_decay numeric,
 	l9_x numeric,
 	l9_y numeric,
 	l9_body numeric,
 	l9_vx numeric,
 	l9_vy numeric,
 	l9_dash_power_rate numeric,
	l9_effort_min numeric,
 	l9_effort_max numeric,
 	l9_extra_stamina numeric,
 	l9_inertia_moment numeric,
 	l9_kick_rand numeric,
 	l9_kickable_margin numeric,
 	l9_player_decay numeric,
 	l10_x numeric,
 	l10_y numeric,
 	l10_body numeric,
 	l10_vx numeric,
 	l10_vy numeric,
 	l10_dash_power_rate numeric,
	l10_effort_min numeric,
 	l10_effort_max numeric,
 	l10_extra_stamina numeric,
 	l10_inertia_moment numeric,
 	l10_kick_rand numeric,
 	l10_kickable_margin numeric,
 	l10_player_decay numeric,
 	l11_x numeric,
 	l11_y numeric,
 	l11_body numeric,
 	l11_vx numeric,
 	l11_vy numeric,
 	l11_dash_power_rate numeric,
	l11_effort_min numeric,
 	l11_effort_max numeric,
 	l11_extra_stamina numeric,
 	l11_inertia_moment numeric,
 	l11_kick_rand numeric,
 	l11_kickable_margin numeric,
 	l11_player_decay numeric,
 	r1_x numeric,
 	r1_y numeric,
 	r1_body numeric,
 	r1_vx numeric,
 	r1_vy numeric,
 	r1_dash_power_rate numeric,
	r1_effort_min numeric,
 	r1_effort_max numeric,
 	r1_extra_stamina numeric,
 	r1_inertia_moment numeric,
 	r1_kick_rand numeric,
 	r1_kickable_margin numeric,
 	r1_player_decay numeric,
 	r2_x numeric,
 	r2_y numeric,
 	r2_body numeric,
 	r2_vx numeric,
 	r2_vy numeric,
 	r2_dash_power_rate numeric,
	r2_effort_min numeric,
 	r2_effort_max numeric,
 	r2_extra_stamina numeric,
 	r2_inertia_moment numeric,
 	r2_kick_rand numeric,
 	r2_kickable_margin numeric,
 	r2_player_decay numeric,
 	r3_x numeric,
 	r3_y numeric,
 	r3_body numeric,
 	r3_vx numeric,
 	r3_vy numeric,
 	r3_dash_power_rate numeric,
	r3_effort_min numeric,
 	r3_effort_max numeric,
 	r3_extra_stamina numeric,
 	r3_inertia_moment numeric,
 	r3_kick_rand numeric,
 	r3_kickable_margin numeric,
 	r3_player_decay numeric,
 	r4_x numeric,
 	r4_y numeric,
 	r4_body numeric,
 	r4_vx numeric,
 	r4_vy numeric,
 	r4_dash_power_rate numeric,
	r4_effort_min numeric,
 	r4_effort_max numeric,
 	r4_extra_stamina numeric,
 	r4_inertia_moment numeric,
 	r4_kick_rand numeric,
 	r4_kickable_margin numeric,
 	r4_player_decay numeric,
 	r5_x numeric,
 	r5_y numeric,
 	r5_body numeric,
 	r5_vx numeric,
 	r5_vy numeric,
 	r5_dash_power_rate numeric,
	r5_effort_min numeric,
 	r5_effort_max numeric,
 	r5_extra_stamina numeric,
 	r5_inertia_moment numeric,
 	r5_kick_rand numeric,
 	r5_kickable_margin numeric,
 	r5_player_decay numeric,
 	r6_x numeric,
 	r6_y numeric,
 	r6_body numeric,
 	r6_vx numeric,
 	r6_vy numeric,
 	r6_dash_power_rate numeric,
	r6_effort_min numeric,
 	r6_effort_max numeric,
 	r6_extra_stamina numeric,
 	r6_inertia_moment numeric,
 	r6_kick_rand numeric,
 	r6_kickable_margin numeric,
 	r6_player_decay numeric,
 	r7_x numeric,
 	r7_y numeric,
 	r7_body numeric,
 	r7_vx numeric,
 	r7_vy numeric,
 	r7_dash_power_rate numeric,
	r7_effort_min numeric,
 	r7_effort_max numeric,
 	r7_extra_stamina numeric,
 	r7_inertia_moment numeric,
 	r7_kick_rand numeric,
 	r7_kickable_margin numeric,
 	r7_player_decay numeric,
 	r8_x numeric,
 	r8_y numeric,
 	r8_body numeric,
 	r8_vx numeric,
 	r8_vy numeric,
 	r8_dash_power_rate numeric,
	r8_effort_min numeric,
 	r8_effort_max numeric,
 	r8_extra_stamina numeric,
 	r8_inertia_moment numeric,
 	r8_kick_rand numeric,
 	r8_kickable_margin numeric,
 	r8_player_decay numeric,
 	r9_x numeric,
 	r9_y numeric,
 	r9_body numeric,
 	r9_vx numeric,
 	r9_vy numeric,
 	r9_dash_power_rate numeric,
	r9_effort_min numeric,
 	r9_effort_max numeric,
 	r9_extra_stamina numeric,
 	r9_inertia_moment numeric,
 	r9_kick_rand numeric,
 	r9_kickable_margin numeric,
 	r9_player_decay numeric,
 	r10_x numeric,
 	r10_y numeric,
 	r10_body numeric,
 	r10_vx numeric,
 	r10_vy numeric,
 	r10_dash_power_rate numeric,
	r10_effort_min numeric,
 	r10_effort_max numeric,
 	r10_extra_stamina numeric,
 	r10_inertia_moment numeric,
 	r10_kick_rand numeric,
 	r10_kickable_margin numeric,
 	r10_player_decay numeric,
 	r11_x numeric,
 	r11_y numeric,
 	r11_body numeric,
 	r11_vx numeric,
 	r11_vy numeric,
 	r11_dash_power_rate numeric,
	r11_effort_min numeric,
 	r11_effort_max numeric,
 	r11_extra_stamina numeric,
 	r11_inertia_moment numeric,
 	r11_kick_rand numeric,
 	r11_kickable_margin numeric,
 	r11_player_decay numeric
) LANGUAGE SQL
BEGIN ATOMIC
    SELECT condensed.* 
	FROM (
        SELECT 
            1+trunc(6072506*random())::int as id -- 6072506 is the size of the materialized view
        FROM generate_series(1,batch_size)
    ) as random
    JOIN shuffled_condensed_matchstates as condensed 
        ON condensed.random_id = random.id;
END;
--      Gets batch of random condensed matchstates + one condensed HELIOS2019 random player (includes the goalkeeper)
CREATE OR REPLACE FUNCTION get_random_condensed_matchstates_and_helios_player (batch_size int)
RETURNS TABLE(
	random_id int,
	matchstate_id int,
	left_teamname varchar(32),
    right_teamname varchar(32),
    cycle int,
    ball_x numeric,
    ball_y numeric,
    ball_vx numeric,
    ball_vy numeric,
 	l1_x numeric,
 	l1_y numeric,
 	l1_body numeric,
 	l1_vx numeric,
 	l1_vy numeric,
 	l1_dash_power_rate numeric,
	l1_effort_min numeric,
 	l1_effort_max numeric,
 	l1_extra_stamina numeric,
 	l1_inertia_moment numeric,
 	l1_kick_rand numeric,
 	l1_kickable_margin numeric,
 	l1_player_decay numeric,
 	l2_x numeric,
 	l2_y numeric,
 	l2_body numeric,
 	l2_vx numeric,
 	l2_vy numeric,
 	l2_dash_power_rate numeric,
	l2_effort_min numeric,
 	l2_effort_max numeric,
 	l2_extra_stamina numeric,
 	l2_inertia_moment numeric,
 	l2_kick_rand numeric,
 	l2_kickable_margin numeric,
 	l2_player_decay numeric,
 	l3_x numeric,
 	l3_y numeric,
 	l3_body numeric,
 	l3_vx numeric,
 	l3_vy numeric,
 	l3_dash_power_rate numeric,
	l3_effort_min numeric,
 	l3_effort_max numeric,
 	l3_extra_stamina numeric,
 	l3_inertia_moment numeric,
 	l3_kick_rand numeric,
 	l3_kickable_margin numeric,
 	l3_player_decay numeric,
 	l4_x numeric,
 	l4_y numeric,
 	l4_body numeric,
 	l4_vx numeric,
 	l4_vy numeric,
 	l4_dash_power_rate numeric,
	l4_effort_min numeric,
 	l4_effort_max numeric,
 	l4_extra_stamina numeric,
 	l4_inertia_moment numeric,
 	l4_kick_rand numeric,
 	l4_kickable_margin numeric,
 	l4_player_decay numeric,
 	l5_x numeric,
 	l5_y numeric,
 	l5_body numeric,
 	l5_vx numeric,
 	l5_vy numeric,
 	l5_dash_power_rate numeric,
	l5_effort_min numeric,
 	l5_effort_max numeric,
 	l5_extra_stamina numeric,
 	l5_inertia_moment numeric,
 	l5_kick_rand numeric,
 	l5_kickable_margin numeric,
 	l5_player_decay numeric,
 	l6_x numeric,
 	l6_y numeric,
 	l6_body numeric,
 	l6_vx numeric,
 	l6_vy numeric,
 	l6_dash_power_rate numeric,
	l6_effort_min numeric,
 	l6_effort_max numeric,
 	l6_extra_stamina numeric,
 	l6_inertia_moment numeric,
 	l6_kick_rand numeric,
 	l6_kickable_margin numeric,
 	l6_player_decay numeric,
 	l7_x numeric,
 	l7_y numeric,
 	l7_body numeric,
 	l7_vx numeric,
 	l7_vy numeric,
 	l7_dash_power_rate numeric,
	l7_effort_min numeric,
 	l7_effort_max numeric,
 	l7_extra_stamina numeric,
 	l7_inertia_moment numeric,
 	l7_kick_rand numeric,
 	l7_kickable_margin numeric,
 	l7_player_decay numeric,
 	l8_x numeric,
 	l8_y numeric,
 	l8_body numeric,
 	l8_vx numeric,
 	l8_vy numeric,
 	l8_dash_power_rate numeric,
	l8_effort_min numeric,
 	l8_effort_max numeric,
 	l8_extra_stamina numeric,
 	l8_inertia_moment numeric,
 	l8_kick_rand numeric,
 	l8_kickable_margin numeric,
 	l8_player_decay numeric,
 	l9_x numeric,
 	l9_y numeric,
 	l9_body numeric,
 	l9_vx numeric,
 	l9_vy numeric,
 	l9_dash_power_rate numeric,
	l9_effort_min numeric,
 	l9_effort_max numeric,
 	l9_extra_stamina numeric,
 	l9_inertia_moment numeric,
 	l9_kick_rand numeric,
 	l9_kickable_margin numeric,
 	l9_player_decay numeric,
 	l10_x numeric,
 	l10_y numeric,
 	l10_body numeric,
 	l10_vx numeric,
 	l10_vy numeric,
 	l10_dash_power_rate numeric,
	l10_effort_min numeric,
 	l10_effort_max numeric,
 	l10_extra_stamina numeric,
 	l10_inertia_moment numeric,
 	l10_kick_rand numeric,
 	l10_kickable_margin numeric,
 	l10_player_decay numeric,
 	l11_x numeric,
 	l11_y numeric,
 	l11_body numeric,
 	l11_vx numeric,
 	l11_vy numeric,
 	l11_dash_power_rate numeric,
	l11_effort_min numeric,
 	l11_effort_max numeric,
 	l11_extra_stamina numeric,
 	l11_inertia_moment numeric,
 	l11_kick_rand numeric,
 	l11_kickable_margin numeric,
 	l11_player_decay numeric,
 	r1_x numeric,
 	r1_y numeric,
 	r1_body numeric,
 	r1_vx numeric,
 	r1_vy numeric,
 	r1_dash_power_rate numeric,
	r1_effort_min numeric,
 	r1_effort_max numeric,
 	r1_extra_stamina numeric,
 	r1_inertia_moment numeric,
 	r1_kick_rand numeric,
 	r1_kickable_margin numeric,
 	r1_player_decay numeric,
 	r2_x numeric,
 	r2_y numeric,
 	r2_body numeric,
 	r2_vx numeric,
 	r2_vy numeric,
 	r2_dash_power_rate numeric,
	r2_effort_min numeric,
 	r2_effort_max numeric,
 	r2_extra_stamina numeric,
 	r2_inertia_moment numeric,
 	r2_kick_rand numeric,
 	r2_kickable_margin numeric,
 	r2_player_decay numeric,
 	r3_x numeric,
 	r3_y numeric,
 	r3_body numeric,
 	r3_vx numeric,
 	r3_vy numeric,
 	r3_dash_power_rate numeric,
	r3_effort_min numeric,
 	r3_effort_max numeric,
 	r3_extra_stamina numeric,
 	r3_inertia_moment numeric,
 	r3_kick_rand numeric,
 	r3_kickable_margin numeric,
 	r3_player_decay numeric,
 	r4_x numeric,
 	r4_y numeric,
 	r4_body numeric,
 	r4_vx numeric,
 	r4_vy numeric,
 	r4_dash_power_rate numeric,
	r4_effort_min numeric,
 	r4_effort_max numeric,
 	r4_extra_stamina numeric,
 	r4_inertia_moment numeric,
 	r4_kick_rand numeric,
 	r4_kickable_margin numeric,
 	r4_player_decay numeric,
 	r5_x numeric,
 	r5_y numeric,
 	r5_body numeric,
 	r5_vx numeric,
 	r5_vy numeric,
 	r5_dash_power_rate numeric,
	r5_effort_min numeric,
 	r5_effort_max numeric,
 	r5_extra_stamina numeric,
 	r5_inertia_moment numeric,
 	r5_kick_rand numeric,
 	r5_kickable_margin numeric,
 	r5_player_decay numeric,
 	r6_x numeric,
 	r6_y numeric,
 	r6_body numeric,
 	r6_vx numeric,
 	r6_vy numeric,
 	r6_dash_power_rate numeric,
	r6_effort_min numeric,
 	r6_effort_max numeric,
 	r6_extra_stamina numeric,
 	r6_inertia_moment numeric,
 	r6_kick_rand numeric,
 	r6_kickable_margin numeric,
 	r6_player_decay numeric,
 	r7_x numeric,
 	r7_y numeric,
 	r7_body numeric,
 	r7_vx numeric,
 	r7_vy numeric,
 	r7_dash_power_rate numeric,
	r7_effort_min numeric,
 	r7_effort_max numeric,
 	r7_extra_stamina numeric,
 	r7_inertia_moment numeric,
 	r7_kick_rand numeric,
 	r7_kickable_margin numeric,
 	r7_player_decay numeric,
 	r8_x numeric,
 	r8_y numeric,
 	r8_body numeric,
 	r8_vx numeric,
 	r8_vy numeric,
 	r8_dash_power_rate numeric,
	r8_effort_min numeric,
 	r8_effort_max numeric,
 	r8_extra_stamina numeric,
 	r8_inertia_moment numeric,
 	r8_kick_rand numeric,
 	r8_kickable_margin numeric,
 	r8_player_decay numeric,
 	r9_x numeric,
 	r9_y numeric,
 	r9_body numeric,
 	r9_vx numeric,
 	r9_vy numeric,
 	r9_dash_power_rate numeric,
	r9_effort_min numeric,
 	r9_effort_max numeric,
 	r9_extra_stamina numeric,
 	r9_inertia_moment numeric,
 	r9_kick_rand numeric,
 	r9_kickable_margin numeric,
 	r9_player_decay numeric,
 	r10_x numeric,
 	r10_y numeric,
 	r10_body numeric,
 	r10_vx numeric,
 	r10_vy numeric,
 	r10_dash_power_rate numeric,
	r10_effort_min numeric,
 	r10_effort_max numeric,
 	r10_extra_stamina numeric,
 	r10_inertia_moment numeric,
 	r10_kick_rand numeric,
 	r10_kickable_margin numeric,
 	r10_player_decay numeric,
 	r11_x numeric,
 	r11_y numeric,
 	r11_body numeric,
 	r11_vx numeric,
 	r11_vy numeric,
 	r11_dash_power_rate numeric,
	r11_effort_min numeric,
 	r11_effort_max numeric,
 	r11_extra_stamina numeric,
 	r11_inertia_moment numeric,
 	r11_kick_rand numeric,
 	r11_kickable_margin numeric,
 	r11_player_decay numeric,
    self_playerstate_id int,
	self_x numeric,
 	self_y numeric,
 	self_body numeric,
 	self_vx numeric,
 	self_vy numeric,
 	self_dash_power_rate numeric,
	self_effort_min numeric,
 	self_effort_max numeric,
 	self_extra_stamina numeric,
 	self_inertia_moment numeric,
 	self_kick_rand numeric,
 	self_kickable_margin numeric,
 	self_player_decay numeric
) LANGUAGE SQL
BEGIN ATOMIC
    SELECT 
        condensed.*,
        heliosplayer_state.playerstate_id,
        heliosplayer_state.x,
		heliosplayer_state.y,
		heliosplayer_state.body,
		heliosplayer_state.vx,
		heliosplayer_state.vy,
        heliosplayer_type.dash_power_rate,
		heliosplayer_type.effort_min,
		heliosplayer_type.effort_max,
		heliosplayer_type.extra_stamina,
		heliosplayer_type.inertia_moment,
		heliosplayer_type.kick_rand,
		heliosplayer_type.kickable_margin,
		heliosplayer_type.player_decay
	FROM (
        SELECT 
            1+trunc(6072506*random())::int as id, -- 6072506 is the size of the materialized view
            1+trunc(11*random())::int as unum
        FROM generate_series(1,batch_size)
    ) as random
    JOIN shuffled_condensed_matchstates as condensed 
        ON condensed.random_id = random.id
    JOIN playerstates as heliosplayer_state
        ON heliosplayer_state.matchstate_id_fk = condensed.matchstate_id
        AND heliosplayer_state.teamname = 'HELIOS2019'
        AND heliosplayer_state.unum = random.unum
    JOIN playertypes as heliosplayer_type
        ON heliosplayer_type.playertype_id = heliosplayer_state.playertype_id_fk;
END;
--      Gets random condensed matchstates + one HELIOS2019 command from a random player (excludes the goalkeeper)
CREATE OR REPLACE FUNCTION get_random_condensed_matchstates_and_helios_player_and_command(batch_size int)
RETURNS TABLE(
	random_id int,
	matchstate_id int,
	left_teamname varchar(32),
    right_teamname varchar(32),
    cycle int,
    ball_x numeric,
    ball_y numeric,
    ball_vx numeric,
    ball_vy numeric,
 	l1_x numeric,
 	l1_y numeric,
 	l1_body numeric,
 	l1_vx numeric,
 	l1_vy numeric,
 	l1_dash_power_rate numeric,
	l1_effort_min numeric,
 	l1_effort_max numeric,
 	l1_extra_stamina numeric,
 	l1_inertia_moment numeric,
 	l1_kick_rand numeric,
 	l1_kickable_margin numeric,
 	l1_player_decay numeric,
 	l2_x numeric,
 	l2_y numeric,
 	l2_body numeric,
 	l2_vx numeric,
 	l2_vy numeric,
 	l2_dash_power_rate numeric,
	l2_effort_min numeric,
 	l2_effort_max numeric,
 	l2_extra_stamina numeric,
 	l2_inertia_moment numeric,
 	l2_kick_rand numeric,
 	l2_kickable_margin numeric,
 	l2_player_decay numeric,
 	l3_x numeric,
 	l3_y numeric,
 	l3_body numeric,
 	l3_vx numeric,
 	l3_vy numeric,
 	l3_dash_power_rate numeric,
	l3_effort_min numeric,
 	l3_effort_max numeric,
 	l3_extra_stamina numeric,
 	l3_inertia_moment numeric,
 	l3_kick_rand numeric,
 	l3_kickable_margin numeric,
 	l3_player_decay numeric,
 	l4_x numeric,
 	l4_y numeric,
 	l4_body numeric,
 	l4_vx numeric,
 	l4_vy numeric,
 	l4_dash_power_rate numeric,
	l4_effort_min numeric,
 	l4_effort_max numeric,
 	l4_extra_stamina numeric,
 	l4_inertia_moment numeric,
 	l4_kick_rand numeric,
 	l4_kickable_margin numeric,
 	l4_player_decay numeric,
 	l5_x numeric,
 	l5_y numeric,
 	l5_body numeric,
 	l5_vx numeric,
 	l5_vy numeric,
 	l5_dash_power_rate numeric,
	l5_effort_min numeric,
 	l5_effort_max numeric,
 	l5_extra_stamina numeric,
 	l5_inertia_moment numeric,
 	l5_kick_rand numeric,
 	l5_kickable_margin numeric,
 	l5_player_decay numeric,
 	l6_x numeric,
 	l6_y numeric,
 	l6_body numeric,
 	l6_vx numeric,
 	l6_vy numeric,
 	l6_dash_power_rate numeric,
	l6_effort_min numeric,
 	l6_effort_max numeric,
 	l6_extra_stamina numeric,
 	l6_inertia_moment numeric,
 	l6_kick_rand numeric,
 	l6_kickable_margin numeric,
 	l6_player_decay numeric,
 	l7_x numeric,
 	l7_y numeric,
 	l7_body numeric,
 	l7_vx numeric,
 	l7_vy numeric,
 	l7_dash_power_rate numeric,
	l7_effort_min numeric,
 	l7_effort_max numeric,
 	l7_extra_stamina numeric,
 	l7_inertia_moment numeric,
 	l7_kick_rand numeric,
 	l7_kickable_margin numeric,
 	l7_player_decay numeric,
 	l8_x numeric,
 	l8_y numeric,
 	l8_body numeric,
 	l8_vx numeric,
 	l8_vy numeric,
 	l8_dash_power_rate numeric,
	l8_effort_min numeric,
 	l8_effort_max numeric,
 	l8_extra_stamina numeric,
 	l8_inertia_moment numeric,
 	l8_kick_rand numeric,
 	l8_kickable_margin numeric,
 	l8_player_decay numeric,
 	l9_x numeric,
 	l9_y numeric,
 	l9_body numeric,
 	l9_vx numeric,
 	l9_vy numeric,
 	l9_dash_power_rate numeric,
	l9_effort_min numeric,
 	l9_effort_max numeric,
 	l9_extra_stamina numeric,
 	l9_inertia_moment numeric,
 	l9_kick_rand numeric,
 	l9_kickable_margin numeric,
 	l9_player_decay numeric,
 	l10_x numeric,
 	l10_y numeric,
 	l10_body numeric,
 	l10_vx numeric,
 	l10_vy numeric,
 	l10_dash_power_rate numeric,
	l10_effort_min numeric,
 	l10_effort_max numeric,
 	l10_extra_stamina numeric,
 	l10_inertia_moment numeric,
 	l10_kick_rand numeric,
 	l10_kickable_margin numeric,
 	l10_player_decay numeric,
 	l11_x numeric,
 	l11_y numeric,
 	l11_body numeric,
 	l11_vx numeric,
 	l11_vy numeric,
 	l11_dash_power_rate numeric,
	l11_effort_min numeric,
 	l11_effort_max numeric,
 	l11_extra_stamina numeric,
 	l11_inertia_moment numeric,
 	l11_kick_rand numeric,
 	l11_kickable_margin numeric,
 	l11_player_decay numeric,
 	r1_x numeric,
 	r1_y numeric,
 	r1_body numeric,
 	r1_vx numeric,
 	r1_vy numeric,
 	r1_dash_power_rate numeric,
	r1_effort_min numeric,
 	r1_effort_max numeric,
 	r1_extra_stamina numeric,
 	r1_inertia_moment numeric,
 	r1_kick_rand numeric,
 	r1_kickable_margin numeric,
 	r1_player_decay numeric,
 	r2_x numeric,
 	r2_y numeric,
 	r2_body numeric,
 	r2_vx numeric,
 	r2_vy numeric,
 	r2_dash_power_rate numeric,
	r2_effort_min numeric,
 	r2_effort_max numeric,
 	r2_extra_stamina numeric,
 	r2_inertia_moment numeric,
 	r2_kick_rand numeric,
 	r2_kickable_margin numeric,
 	r2_player_decay numeric,
 	r3_x numeric,
 	r3_y numeric,
 	r3_body numeric,
 	r3_vx numeric,
 	r3_vy numeric,
 	r3_dash_power_rate numeric,
	r3_effort_min numeric,
 	r3_effort_max numeric,
 	r3_extra_stamina numeric,
 	r3_inertia_moment numeric,
 	r3_kick_rand numeric,
 	r3_kickable_margin numeric,
 	r3_player_decay numeric,
 	r4_x numeric,
 	r4_y numeric,
 	r4_body numeric,
 	r4_vx numeric,
 	r4_vy numeric,
 	r4_dash_power_rate numeric,
	r4_effort_min numeric,
 	r4_effort_max numeric,
 	r4_extra_stamina numeric,
 	r4_inertia_moment numeric,
 	r4_kick_rand numeric,
 	r4_kickable_margin numeric,
 	r4_player_decay numeric,
 	r5_x numeric,
 	r5_y numeric,
 	r5_body numeric,
 	r5_vx numeric,
 	r5_vy numeric,
 	r5_dash_power_rate numeric,
	r5_effort_min numeric,
 	r5_effort_max numeric,
 	r5_extra_stamina numeric,
 	r5_inertia_moment numeric,
 	r5_kick_rand numeric,
 	r5_kickable_margin numeric,
 	r5_player_decay numeric,
 	r6_x numeric,
 	r6_y numeric,
 	r6_body numeric,
 	r6_vx numeric,
 	r6_vy numeric,
 	r6_dash_power_rate numeric,
	r6_effort_min numeric,
 	r6_effort_max numeric,
 	r6_extra_stamina numeric,
 	r6_inertia_moment numeric,
 	r6_kick_rand numeric,
 	r6_kickable_margin numeric,
 	r6_player_decay numeric,
 	r7_x numeric,
 	r7_y numeric,
 	r7_body numeric,
 	r7_vx numeric,
 	r7_vy numeric,
 	r7_dash_power_rate numeric,
	r7_effort_min numeric,
 	r7_effort_max numeric,
 	r7_extra_stamina numeric,
 	r7_inertia_moment numeric,
 	r7_kick_rand numeric,
 	r7_kickable_margin numeric,
 	r7_player_decay numeric,
 	r8_x numeric,
 	r8_y numeric,
 	r8_body numeric,
 	r8_vx numeric,
 	r8_vy numeric,
 	r8_dash_power_rate numeric,
	r8_effort_min numeric,
 	r8_effort_max numeric,
 	r8_extra_stamina numeric,
 	r8_inertia_moment numeric,
 	r8_kick_rand numeric,
 	r8_kickable_margin numeric,
 	r8_player_decay numeric,
 	r9_x numeric,
 	r9_y numeric,
 	r9_body numeric,
 	r9_vx numeric,
 	r9_vy numeric,
 	r9_dash_power_rate numeric,
	r9_effort_min numeric,
 	r9_effort_max numeric,
 	r9_extra_stamina numeric,
 	r9_inertia_moment numeric,
 	r9_kick_rand numeric,
 	r9_kickable_margin numeric,
 	r9_player_decay numeric,
 	r10_x numeric,
 	r10_y numeric,
 	r10_body numeric,
 	r10_vx numeric,
 	r10_vy numeric,
 	r10_dash_power_rate numeric,
	r10_effort_min numeric,
 	r10_effort_max numeric,
 	r10_extra_stamina numeric,
 	r10_inertia_moment numeric,
 	r10_kick_rand numeric,
 	r10_kickable_margin numeric,
 	r10_player_decay numeric,
 	r11_x numeric,
 	r11_y numeric,
 	r11_body numeric,
 	r11_vx numeric,
 	r11_vy numeric,
 	r11_dash_power_rate numeric,
	r11_effort_min numeric,
 	r11_effort_max numeric,
 	r11_extra_stamina numeric,
 	r11_inertia_moment numeric,
 	r11_kick_rand numeric,
 	r11_kickable_margin numeric,
 	r11_player_decay numeric,
	self_playerstate_id int,
	self_x numeric,
 	self_y numeric,
 	self_body numeric,
 	self_vx numeric,
 	self_vy numeric,
 	self_dash_power_rate numeric,
	self_effort_min numeric,
 	self_effort_max numeric,
 	self_extra_stamina numeric,
 	self_inertia_moment numeric,
 	self_kick_rand numeric,
 	self_kickable_margin numeric,
 	self_player_decay numeric,
    commandtype varchar
) LANGUAGE SQL
BEGIN ATOMIC
    SELECT 
        condensed_match_and_helios_player.*,
        helios_command.playercommand_type
    FROM get_random_condensed_matchstates_and_helios_player(batch_size) as condensed_match_and_helios_player
    JOIN playercommands as helios_command
        ON helios_command.playerstate_id_fk = condensed_match_and_helios_player.self_playerstate_id;
END;

COMMIT;
